<template>
  <div class="bg-white rounded-md border border-gray-300 shadow-sm relative">
    <barloader :loading="loading" />

    <div v-if="hasSlot('title')" class="title px-5 py-3 border-b">
      <h4 class="font-oswald">
        <slot name="title"></slot>
      </h4>
    </div>

    <div class="p-3 text-sm">
      <slot></slot>
    </div>

    <div v-if="hasSlot('footer')" class="footer">
      <slot name="footer"></slot>
    </div>
  </div>
</template>

<script lang="ts">
import { defineComponent } from 'vue';
import BarLoader from '@/core/components/BarLoader/BarLoader.vue';

export default defineComponent({
  name: 'box-container',
  components: {
    barloader: BarLoader,
  },
  props: {
    loading: { type: Boolean, required: false, default: false },
  },
  setup(_, { slots }) {
    function hasSlot(slot: string): boolean {
      return !!slots[slot];
    }

    return { hasSlot };
  },
});
</script>

<style lang="scss" scoped>
@import '../../../assets/css/variables.scss';

.title {
  h4 {
    font-size: 18px;
    color: $color-blue;
    display: inline-block;

    &:after {
      content: "";
      display: block;
      position: relative;
      bottom: -13px;
      z-index: 100;
      width: auto;
      height: 1px;
      padding: 0 0 0 0;
      margin: 0 -35px 0 0;
      background-color: $color-blue;
    }
  }
}
</style>